//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//-- This confidential and proprietary software may be used only as authorized 
//-- by a licensing agreement from ESD University of Verona - EDALab s.r.l.                      
//--                                                                            
//--                                                                           
//-- Title:             Multimedia System Design Developement
//-- Project:           V-CLIP 1.0
//--    
//-- 
//-- File:              b01_UT.h
//-- Author:            Nicola Bombieri
//-- Date:              29 November 2005 
//-- Description:       LT b01 module
//-- 
//-- Mod History: $Log: $
//                                                                            
//----------------------------------------------------------------------------
//-- RCS Version:  $Id: $                                           
//----------------------------------------------------------------------------

// Modified by Nannan

#include <systemc.h>
// DATA TYPE DEFINITIONS

// Added for the simulation of abstracted ADPCM module.
struct iostruct {
	//nuovi
	bool line1;
	bool line2;
	bool outp;
	bool overflw;
	
};

//typedef unsigned int ADDRESS_TYPE;

#define READ_ADDR 1
#define WRITE_ADDR 2
#define B01_ADDR 5

SC_MODULE(b01_UT)
{
	iostruct ioDataStruct;
	
	int stato;
	
	void process();
	void end_of_elaboration();

	SC_CTOR(b01_UT)
	{
		SC_THREAD(process);
	}  
};

