#include <iostream>
#include "systemc.h"
#include "bcd_to_binary_L.h"

void bcd_to_binary_L::convert_code_1()
{
  sc_uint<5> tmp = dat_bcd_i.read();
  tens_digit.write(tmp.range(3,0) + 10);
  no_tens_digit.write(tmp.range(3,0));
  tens_select.write(tmp[4]);
	//std::cout << sc_time_stamp() << "I1:" << tens_digit.read() << " " << no_tens_digit.read() << " " << tens_select.read() << std::endl;
}

void bcd_to_binary_L::convert_code_2()
{
  if(tens_select.read())
    dat_bin_o.write(tens_digit.read());
  else
    dat_bin_o.write(no_tens_digit.read());
	//std::cout << sc_time_stamp() << "I2:" << dat_bin_o.read() << std::endl;
}

void bcd_to_binary_L::convert_code_gray()
{
  sc_uint<4> tmp;
  sc_uint<4> tmp2;

  tmp2 = dat_bin_o.read();
  tmp[3] = tmp2[3];
  tmp[2] = tmp2[3] ^ tmp2[2];
  tmp[1] = tmp2[2] ^ tmp2[1];
  tmp[0] = tmp2[1] ^ tmp2[0];

  dat_gray_o.write(tmp);
	//std::cout << sc_time_stamp() << "I3:" << dat_gray_o.read() << std::endl;
}

