#include "systemc.h"
#include "hostSlaveMuxBI_H.h"

SC_MODULE(hostSlaveMux_H)
{
  sc_uint<8>  SIEPortCtrlInToSIE;
  sc_uint<8>  SIEPortCtrlInFromHost;
  sc_uint<8>  SIEPortCtrlInFromSlave;
  sc_uint<8>  SIEPortDataInToSIE; 
  sc_uint<8>  SIEPortDataInFromHost; 
  sc_uint<8>  SIEPortDataInFromSlave; 
  bool SIEPortWEnToSIE; 
  bool SIEPortWEnFromHost; 
  bool SIEPortWEnFromSlave; 
  bool fullSpeedPolarityToSIE;
  bool fullSpeedPolarityFromHost;
  bool fullSpeedPolarityFromSlave;
  bool fullSpeedBitRateToSIE;
  bool fullSpeedBitRateFromHost;
  bool fullSpeedBitRateFromSlave;
  bool noActivityTimeOutEnableToSIE;
  bool noActivityTimeOutEnableFromHost;
  bool noActivityTimeOutEnableFromSlave;
 
 //hostSlaveMuxBI
  sc_uint<8>  dataIn;
  bool address;
  bool writeEn;
  bool strobe_i;
  bool busClk;
  bool usbClk;
  bool rstFromWire;
  bool hostSlaveMuxSel;
  bool rstSyncToBusClkOut;
  bool rstSyncToUsbClkOut;
  sc_uint<8>  dataOut;

  void host_slave_mux(bool);
  void run();

  hostSlaveMuxBI_H *ins;
  //internal wires and regs
  bool hostMode;

  SC_CTOR(hostSlaveMux_H)
  {
    SC_THREAD(run);
  }
};

